/*
 * --COPYRIGHT--,BSD Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved. Redistribution and use in source and binary
 * forms, with or without modification, are permitted provided that the
 * following conditions are met: * Redistributions of source code must
 * retain the above copyright notice, this list of conditions and the
 * following disclaimer. * Redistributions in binary form must reproduce
 * the above copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided with
 * the distribution. * Neither the name of Texas Instruments Incorporated
 * nor the names of its contributors may be used to endorse or promote
 * products derived from this software without specific prior written
 * permission. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE. --/COPYRIGHT--
 */

//******************************************************************************
//  Jose I Quinones
//  Texas Instruments Inc.
//  June 2009
//  Built with IAR Embedded Workbench Version: 3.42A
//******************************************************************************
//***********************************************************************************
// Communication Engine Globals                                                     *
//***********************************************************************************

//***********************************************************************************
// Firmware Revision                                                                *
// Date: 2/28/06    By: Jose I Quinones                                             *
// Changes:                                                                         *
// TASK0.CPP    -   Fixed a series of ENABLEA_BIT bit sets to Windings B,C&D        *
//***********************************************************************************

#define     FIRMWARE_REVISION       (0xA6)

//***********************************************************************************
// Application Specific Definitions                                                 *
//***********************************************************************************

#define     SPI_PORT            P1OUT
#define     SPI_PORTIN          P1IN
#define     SPI_STROBE          (0x01)
#define     SPI_DATA_OUT_PIN    (0x02)
#define     SPI_DATA_IN_PIN     (0x04)
#define     SPI_CLK             (0x08)
#define     StatusLEDPin        (0x80)

//***********************************************************************************
// Application Specific Opcodes                                                     *
//***********************************************************************************
#define     SEND_SPI        0
#define     INIT_CLK        1

// Serial Command Byte names
#define     OPCODE          SerialBuffer[0]
#define     SPI3            SerialBuffer[1]
#define     SPI2            SerialBuffer[2]
#define     SPI1            SerialBuffer[3]
#define     SPI0            SerialBuffer[4]
#define     SPI_PARAM       SerialBuffer[5]

#define     SET_GPIO        0x00
#define     PWM_ENABLE      0x01
#define     PWM_PHASE       0x02

//Memory Access Opcodes
#define     READ_MEM        0xE0
#define     WRITE_WMEM      0xE1
#define     WRITE_BMEM      0xE2

// System Opcodes
#define     GET_FW_REV      0xF0
#define     RESET_MCU       0xF1
#define     SHOW_CLKS       0xF2
